import 'package:zhiying_comm/zhiying_comm.dart';

class CustomQuickEntryModel {
  String name;
  String desc;
  String pagination;
  String moduleType;
  String moduleKey;
  String isTopMargin;
  String isLeftRightMargin;
  String isShow;
  String topMargin;
  String leftRightMargin;
  String rowSize;
  String columnSize;
  String isShowSubTitle;
  String isShowTitle;
  String isShowCornerIcon;
  String isShowCategory;
  String paginationSelectColor;
  String paginationUnselectColor;
  List<ListStyle> listStyle;
  List<TypeList> typeList;
  int moduleKeyId;
  String titleColor;
  String subTitleColor;

  CustomQuickEntryModel({
    this.name,
    this.desc,
    this.pagination,
    this.moduleType,
    this.moduleKey,
    this.isTopMargin,
    this.isLeftRightMargin,
    this.isShow,
    this.topMargin,
    this.leftRightMargin,
    this.rowSize,
    this.isShowSubTitle,
    this.isShowCornerIcon,
    this.isShowCategory,
    this.paginationSelectColor,
    this.paginationUnselectColor,
    this.listStyle,
    this.typeList,
    this.moduleKeyId,
    this.titleColor,
    this.subTitleColor,
    this.columnSize,
    this.isShowTitle,
  });

  CustomQuickEntryModel.fromJson(Map<String, dynamic> json) {
    name = json['name']?.toString();
    desc = json['desc']?.toString();
    pagination = json['pagination']?.toString();
    moduleType = json['module_type']?.toString();
    moduleKey = json['module_key']?.toString();
    isTopMargin = json['is_top_margin']?.toString();
    isLeftRightMargin = json['is_left_right_margin']?.toString();
    isShow = json['is_show']?.toString();
    topMargin = json['top_margin']?.toString();
    leftRightMargin = json['left_right_margin']?.toString();
    rowSize = json['row_size']?.toString();
    columnSize = json['column_size']?.toString() ?? '5';
    isShowSubTitle = json['is_show_sub_title']?.toString();
    isShowCornerIcon = json['is_show_corner_icon']?.toString();
    isShowCategory = json['is_show_category']?.toString();
    paginationSelectColor = json['pagination_select_color']?.toString();
    paginationUnselectColor = json['pagination_unselect_color']?.toString();
    if (json['list_style'] != null) {
      listStyle = new List<ListStyle>();
      json['list_style'].forEach((v) {
        listStyle.add(new ListStyle.fromJson(v));
      });
    }
    if (json['type_list'] != null) {
      typeList = new List<TypeList>();
      json['type_list'].forEach((v) {
        typeList.add(new TypeList.fromJson(v));
      });
    }
    moduleKeyId = json['module_key_id'];
    titleColor = json['title_color'];
    subTitleColor = json['sub_title_color'];
    isShowTitle = '1';
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['name'] = this.name;
    data['desc'] = this.desc;
    data['pagination'] = this.pagination;
    data['module_type'] = this.moduleType;
    data['module_key'] = this.moduleKey;
    data['is_top_margin'] = this.isTopMargin;
    data['is_left_right_margin'] = this.isLeftRightMargin;
    data['is_show'] = this.isShow;
    data['top_margin'] = this.topMargin;
    data['left_right_margin'] = this.leftRightMargin;
    data['row_size'] = this.rowSize;
    data['column_size'] = this.columnSize;
    data['is_show_sub_title'] = this.isShowSubTitle;
    data['is_show_corner_icon'] = this.isShowCornerIcon;
    data['is_show_category'] = this.isShowCategory;
    data['pagination_select_color'] = this.paginationSelectColor;
    data['pagination_unselect_color'] = this.paginationUnselectColor;
    if (this.listStyle != null) {
      data['list_style'] = this.listStyle.map((v) => v.toJson()).toList();
    }
    if (this.typeList != null) {
      data['type_list'] = this.typeList.map((v) => v.toJson()).toList();
    }
    data['module_key_id'] = this.moduleKeyId;
    data['title_color'] = this.titleColor;
    data['sub_title_color'] = this.subTitleColor;
    data['is_show_title'] = this.isShowTitle;
    return data;
  }
}

class ListStyle extends SkipModel {
  String title;
  String img;
  String subTitle;
  String typeListKey;
  String rightIcon;
  String requiredLogin;
  String requiredTaobaoAuth;
  String skipIdentifier;

  ListStyle({
    this.title,
    this.img,
    this.subTitle,
    this.typeListKey,
    this.rightIcon,
    this.requiredLogin,
    this.requiredTaobaoAuth,
    this.skipIdentifier,
  });

  ListStyle.fromJson(Map<String, dynamic> json) {
    super.fromJson(json);
    title = json['title'];
    img = json['img'];
    subTitle = json['sub_title'];
    typeListKey = json['type_list_key'];
    rightIcon = json['right_icon'];
    requiredLogin = json['required_login'];
    requiredTaobaoAuth = json['required_taobao_auth'];
    skipIdentifier = json['skip_identifier'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['title'] = this.title;
    data['img'] = this.img;
    data['sub_title'] = this.subTitle;
    data['type_list_key'] = this.typeListKey;
    data['right_icon'] = this.rightIcon;
    data['required_login'] = this.requiredLogin;
    data['required_taobao_auth'] = this.requiredTaobaoAuth;
    data['skip_identifier'] = this.skipIdentifier;
    return data;
  }
}

class TypeList {
  String name;
  String key;

  TypeList({this.name, this.key});

  TypeList.fromJson(Map<String, dynamic> json) {
    name = json['name'];
    key = json['key'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['name'] = this.name;
    data['key'] = this.key;
    return data;
  }
}
